-----------------------------------------------------------------------------
--
-- data
--   \damageDealt
--     \<damageDealerName>
--       -count, amount, maximumAmount, maximumAmountAttack
--       \damageTypeDetails
--         \<damageTypeLocal>
--			 -count, amount
--       \attackDetails
--         \<attackName>
--            -count, amount, maximumAmount, damageType
--            \hitDetails
--			    \<attackType> -- one of Hit, Critical Hit, Tick, Miss, Dodge, Resist, etc.
--                -count, amount
--   \damageTaken
--     \<damageTakerName>
--       -count, amount, maximumAmount, maximumAmountAttack
--       \damageTypeDetails
--         \<damageTypeLocal>
--			 -count, amount
--       \attackDetails
--         \<attackName>
--            -count, amount, maximumAmount, damageType
--            \hitDetails
--  			\<attackType>
--
-----------------------------------------------------------------------------

local L = AceLibrary("AceLocale-2.2"):new("AssessmentDamage")
L:RegisterTranslations("enUS", function() return {
	["Damage"] = true,
	["Damage Options."] = true,
	["Merge Pet Damage"] = true,
	["Merges damage dealt by pets with their owners data."] = true,

	["Damage Dealers"] = true,
	["Damage Takers"] = true,
	["Damage Dealt"] = true,
	["Fight Damage Dealt"] = true,
	["Damage Dealt Details"] = true,
	["Damage Type Dealt Details"] = true,
	["Damage Dealt Hit Details"] = true,
	["DPS"] = true,
	
	["Highest Hits"] = true,

	["Damage Taken"] = true,
	["Damage Type Taken Details"] = true,
	["Damage Taken Details"] = true,
	["Damage Taken Hit Details"] = true,
	["DPS"] = true,
	["Fight Damage Taken"] = true,

	["Hit"] = true,
	["Critical Hit"] = true,
	["Tick"] = true,
	["Partial Absorb"] = true,
	["Partial Block"] = true,
	["Partial Resist"] = true,
	["Melee"] = true,
	
	["Pet: "] = true,

	["Damage Type"] = true,
	["Colors"] = true,
	["Color options"] = true,

	["Damage Type Data"] = true,
	["Information regarding damage types taken: Fire, Frost, etc."] = true,
	["Attack Data"] = true,
	["Information about each attack used."] = true,
	["Hit Data"] = true,
	["Detailed information about each attack used."] = true,
	["Max Data"] = true,
	["Gather maximum hit data."] = true,
	
	["FILTER_NONE"]	= "Gather no data.",
	["FILTER_SELF"] = "Gather self data only.",
	["FILTER_ALL"]	= "Gather all data.",
} end)

L:RegisterTranslations("koKR", function() return {
	["Damage"] = "피해량",
	["Damage Options."] = "피해량 설정입니다.",
	["Merge Pet Damage"] = "소환수 피해량 병합",
	["Merges damage dealt by pets with their owners data."] = "소환수가 입힌 피해량을 주인의 데이터화 합칩니다.",

	["Damage Dealers"] = "데미지 딜러",
	["Damage Takers"] = "데미지 탱커",
	["Damage Dealt"] = "입힌 피해량",
	["Fight Damage Dealt"] = "최근 입힌 피해량",
	["Damage Dealt Details"] = "입힌 피해량 상세정보",
	["Damage Type Dealt Details"] = "입힌 피해 종류 상세정보",
	["Damage Dealt Hit Details"] = "입힌 피해량 타격 상세정보",
	["DPS"] = "DPS",
	
	["Highest Hits"] = "최고 타격",

	["Damage Taken"] = "받은 피해량",
	["Damage Type Taken Details"] = "받은 피해 종류 상세정보",
	["Damage Taken Details"] = "받은 피해량 상세정보",
	["Damage Taken Hit Details"] = "받은 피해량 타격 상세정보",
	["DPS"] = "DPS",
	["Fight Damage Taken"] = "최근 받은 피해량",

	["Hit"] = "타격",
	["Critical Hit"] = "치명타",
	["Tick"] = "틱당",
	["Partial Absorb"] = "부분적인 흡수",
	["Partial Block"] = "부분적인 방어",
	["Partial Resist"] = "부분적인 저항",
	["Melee"] = "근접",
	
	["Pet: "] = "소환수:",

	["Damage Type"] = "피해 종류",
	["Colors"] = "색상",
	["Color options"] = "색상 설정입니다.",

	["Damage Type Data"] = "피해 종류 데이터",
	["Information regarding damage types taken: Fire, Frost, etc."] = "받은 피해의 종류에 관한 정보: 화염, 냉기, 등.",
	["Attack Data"] = "공격 데이터",
	["Information about each attack used."] = "사용한 각 공격에 대한 정보입니다.",
	["Hit Data"] = "타격 데이터",
	["Detailed information about each attack used."] = "사용한 각 공격에 대한 상세정보입니다.",
	["Max Data"] = "최대 데이터",
	["Gather maximum hit data."] = "수집할 타격 데이터의 최대입니다.",
	
	["FILTER_NONE"]	= "데이터를 수집하지 않습니다.",
	["FILTER_SELF"] = "자신의 데이터만 수집합니다.",
	["FILTER_ALL"]	= "모든 데이터를 수집합니다.",
} end)

-----------------------------------------------------------------------------

local AssessmentDamage = Assessment:NewModule("Damage", "AceEvent-2.0", "Parser-3.0")
AssessmentDamage.db = Assessment:AcquireDBNamespace("Damage")
Assessment:RegisterDefaults("Damage", "profile", {
	enable						= true,
	mergePetWithOwner			= true,
	gatherDamageTypeDataFilter	= "ALL",
	gatherAttackDataFilter		= "ALL",
	gatherHitDataFilter			= "ALL",
	gatherMaximumDataFilter		= "ALL",
	colors =
	{
		physical	= { 1, 0.75, 0.46 },
		holy		= { 1, 1, 0.5 },
		fire		= { 1, 0.3, 0 },
		nature		= { 0.5, 1, 0.2 },
		frost		= { 0.4, 0.6, 0.9 },
		shadow		= { 0.7, 0.4, 1 },
		arcane		= { 0.8, 0.8, 1 },
		unknown		= { 0, 0, 0 },
	}
})

local profile
local profileColors
local gatherDamageTypeMethod
local gatherAttackDataMethod
local gatherHitDataMethod
local gatherMaximumDataMethod

local emptyMethod = Assessment.EmptyMethod

-----------------------------------------------------------------------------

Assessment.TagData.DamageDealt =
{
	method = function(data)
				local fightData = data.fightData
				if not fightData then return 0 end
				
				local damageDealt = fightData.damageDealt
				if not damageDealt then return 0 end

				local playerDamage = damageDealt[data.key]
				if not playerDamage then return 0 end
				
				return playerDamage.amount
			 end,
	data = "damage",
	guaranteeResult = true,
	numeric = true,
}

Assessment.TagData.MaximumDamageDealt =
{
	method = function(data)
				local fightData = data.fightData
				if not fightData then return 0 end
				
				local damageDealt = fightData.damageDealt
				if not damageDealt then return 0 end
				
				local playerDamage = damageDealt[data.key]
				if not playerDamage then return 0 end
				
				return playerDamage.maximumAmount or 0
			 end,
	data = "damage",
	guaranteeResult = true,
	numeric = true,
}

Assessment.TagData.MaximumDamageDealtAttack =
{
	method = function(data)
				local fightData = data.fightData
				if not fightData then return end
				
				local damageDealt = fightData.damageDealt
				if not damageDealt then return end
				
				local playerDamage = damageDealt[data.key]
				if not playerDamage then return end
				
				return playerDamage.maximumAmountAttack
			 end,
	data = "damage",
}

Assessment.TagData.DamageTaken =
{
	method = function(data)
				local fightData = data.fightData
				if not fightData then return 0 end
				
				local damageTaken = fightData.damageTaken
				if not damageTaken then return 0 end
				
				local playerDamage = damageTaken[data.key]				
				if not playerDamage then return 0 end
				
				return playerDamage.amount
			 end,
	data = "damage",
	guaranteeResult = true,
	numeric = true,
}

Assessment.TagData.MaximumDamageTaken =
{
	method = function(data)
				local fightData = data.fightData
				if not fightData then return 0 end
				
				local damageTaken = fightData.damageTaken
				if not damageTaken then return 0 end
				
				local playerDamage = damageTaken[data.key]				
				if not playerDamage then return 0 end

				return playerDamage.maximumAmount or 0
			 end,
	data = "damage",
	guaranteeResult = true,
	numeric = true,
}

Assessment.TagData.MaximumDamageTakenAttack =
{
	method = function(data)
				local fightData = data.fightData
				if not fightData then return end
				
				local damageTaken = fightData.damageTaken
				if not damageTaken then return end
				
				local playerDamage = damageTaken[data.key]				
				if not playerDamage then return 0 end

				return playerDamage.maximumAmountAttack
			 end,
	data = "damage",
}

Assessment.TagData.MaximumAmountAttack =
{
	tableData = "value.maximumAmountAttack",
	numeric = true
}

Assessment.TagData.AbsorbAmount =
{
	tableData = "value.absorbAmount",
	numeric = true
}

Assessment.TagData.BlockAmount =
{
	tableData = "value.blockAmount",
	numeric = true
}

Assessment.TagData.MissCount =
{
	tableData = "value.count",
	numeric = true
}

Assessment.TagData.ResistAmount =
{
	tableData = "value.resistAmount",
	numeric = true
}

-----------------------------------------------------------------------------

Assessment.ListType.DamageDealers =
{
	method = function(fightData)
				if not fightData or not fightData.damageDealt then return emptyMethod end
				return pairs(fightData.damageDealt)
			 end,
	data = "damage",
	description = L["Damage Dealers"],
}

Assessment.ListType.DamageTakers =
{
	method = function(fightData)
				if not fightData or not fightData.damageTaken then return emptyMethod end
				return pairs(fightData.damageTaken)
			 end,
	data = "damage",
	description = L["Damage Takers"],
}

-----------------------------------------------------------------------------

Assessment.ListType.EnumerateTable.updateData.damageDealt = "damage"
Assessment.ListType.EnumerateTable.updateData.damageTaken = "damage"

-----------------------------------------------------------------------------

local playerName = UnitName("player")
local gatherFilterMethods =
{
	NONE	= function() return false end,
	SELF	= function(name) return name == playerName end,
	ALL		= function() return true end,
}

-----------------------------------------------------------------------------

Assessment.DefaultDisplaySets.DamageType =
{
	titleTag			= "[WindowParameter(1)]",
	listType			= "EnumerateTable", 
	listDataTag			= "[WindowParameterList],damageTypeDetails",
	barValueTag			= "Amount", 
	filterTag			= "1",
	sortKeyTag			= "BarValue",
	fightIndex			= -1,
	text				= { { }, { tag= "[BarValue:Short]" } },
	description			= L["Damage Type"],
	colorTypeList		= { "DamageType", count = 1 },
	favorite			= false,
	selectable			= false,
}

Assessment.DefaultDisplaySets.DamageDealtHitDetails =
{
	titleTag			= "[WindowParameter(1)]: [WindowParameter(2)]",
	listType			= "EnumerateTable", 
	listDataTag			= "damageDealt,[WindowParameter(1)],attackDetails,[WindowParameter(2)],hitDetails",
	barValueTag			= "Amount",
	filterTag			= "1",
	fightIndex			= -1,
	text				= { { tag = "[Rank]. [Key] ([Count])" }, { tag = "[BarValue:Short]" }, { tag = "Average: [(BarValue/Count):Format(\"%.1f\")]", visible = false }, count = 3 },
	description			= L["Damage Dealt Hit Details"],
	selectable			= false,
--	colorTypeList		= { "Custom" },
}

Assessment.DefaultDisplaySets.DamageDealtDetails =
{
	titleTag			= "[(FightIndex ~= 0):\"Fight \"]Damage Dealt: [WindowParameter(1)]",
	listType			= "EnumerateTable", 
	listDataTag			= "damageDealt,[windowParameter(1)],attackDetails",
	barValueTag			= "Amount",
	filterTag			= "1",
	fightIndex			= -1,
	text				= { { tag = "[Rank]. [Key] ([Count])" }, { tag = "[BarValue:Short]" }, { tag = "Average: [(BarValue/Count):Format(\"%.1f\")][MaximumAmount:Prefix(\", Maximum: \")]", visible = false }, count = 3 },
	description			= L["Damage Dealt Details"],
	selectable			= false,
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= L["Damage Dealt Hit Details"],
	onClickData			= "[WindowParameter(1)],[Key]",
	colorTypeList		= { "SpellDamageType", count = 1 },
}

Assessment.DefaultDisplaySets.DamageTypeDealtDetails =
{
	titleTag			= "[(fightIndex ~= 0):\"Fight \"]Damage Type Dealt: [windowParameter(1)]",
	listType			= "EnumerateTable", 
	listDataTag			= "damageDealt,[WindowParameter(1)],damageTypeDetails",
	barValueTag			= "Amount",
	filterTag			= "1",
	fightIndex			= -1,
	text				= { { tag = "[Rank]. [Key] ([Count])" }, { tag = "[BarValue:Short]" }, { tag = "[(BarValue*100/TotalBarValue):Format(\"%.1f%%\")]", visible = false }, count = 3 },
	description			= L["Damage Type Dealt Details"],
	selectable			= false,
	colorTypeList		= { "DamageType", count = 1 },
}

Assessment.DefaultDisplaySets.DamageDealt =
{
	titleTag			= "Damage Dealt: [TotalBarValue:short]",
	listType			= "GroupMembers", 
	barValueTag			= "DamageDealt", 
	filterTag			= "BarValue ~= 0",
	fightIndex			= 0,
	text				= { { }, { tag= "[BarValue:Short]" }, { tag = "[(BarValue*100/TotalBarValue):Format(\"%.1f%%\")]", visible = false }, count = 3 },
	description			= L["Damage Dealt"],
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= string.format("[Select(IsControlKeyDown, %q, %q)]", L["Damage Type Dealt Details"], L["Damage Dealt Details"]),
	onClickData			= "[Key]",
	segmentEnable		= false,
	segmentDisplaySet	= L["Damage Type"],
	segmentData			= "damageDealt,[Key]",
	colorTypeList		= { "Class", count = 1 },
}

Assessment.DefaultDisplaySets.FightDamageDealt =
{
	titleTag			= "Fight Damage Dealt: [TotalBarValue:Short]",
	listType			= "GroupMembers", 
	barValueTag			= "DamageDealt", 
	filterTag			= "BarValue ~= 0",
	fightIndex			= 1,
	text				= { { }, { tag= "[BarValue:Short]" }, { tag = "[(BarValue*100/TotalBarValue):Format(\"%.1f%%\")]", visible = false }, count = 3 },
	description			= L["Fight Damage Dealt"],
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= string.format("[select(IsControlKeyDown, %q, %q)]", L["Damage Type Dealt Details"], L["Damage Dealt Details"]),
	onClickData			= "[Key]",
	segmentEnable		= false,
	segmentDisplaySet	= L["Damage Type"],
	segmentData			= "damageDealt,[Key]",
	colorTypeList		= { "Class", count = 1 },
}

Assessment.DefaultDisplaySets.HighestHits =
{
	titleTag			= "Highest Hits",
	listType			= "GroupMembers", 
	barValueTag			= "MaximumDamageDealt", 
	filterTag			= "BarValue ~= 0",
	fightIndex			= 0,
	text				= { { tag = "[Rank]. [Key]: [MaximumDamageDealtAttack]" }, { tag= "[BarValue:Short]" } },
	description			= L["Highest Hits"],
	colorTypeList		= { "Class", count = 1 },
	favorite			= false,
}

Assessment.DefaultDisplaySets.DPS =
{
	titleTag			= "DPS: [CombatDuration:FormatDuration]",
	listType			= "GroupMembers", 
	barValueTag			= "DamageDealt / Maximum(CombatDuration, 1)", 
	filterTag			= "BarValue ~= 0",
	fightIndex			= 1,
	text				= { { }, { tag= "[BarValue:Format(\"%.1f\")]" }, { tag = "[(BarValue*100/TotalBarValue):Format(\"%.1f%%\")]", visible = false }, count = 3  },
	description			= L["DPS"],
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= string.format("[Select(IsControlKeyDown, %q, %q)]", L["Damage Type Dealt Details"], L["Damage Dealt Details"]),
	onClickData			= "[Key]",
	favorite			= false,
	segmentEnable		= false,
	segmentDisplaySet	= L["Damage Type"],
	segmentData			= "damageDealt,[Key]",
	colorTypeList		= { "Class", count = 1 },
}

Assessment.DefaultDisplaySets.DamageTakentHitDetails =
{
	titleTag			= "[WindowParameter(1)]: [WindowParameter(2)]",
	listType			= "EnumerateTable", 
	listDataTag			= "damageTaken,[WindowParameter(1)],attackDetails,[WindowParameter(2)],hitDetails",
	barValueTag			= "Amount",
	filterTag			= "1",
	fightIndex			= -1,
	text				= { { tag = "[Rank]. [Key] ([Count])" }, { tag = "[BarValue:Short]" } },
	description			= L["Damage Taken Hit Details"],
	selectable			= false,
--	colorTypeList		= { "Spell" },
}

Assessment.DefaultDisplaySets.DamageTypeTakenDetails =
{
	titleTag			= "[(FightIndex ~= 0):\"Fight \"]Damage Type Taken: [WindowParameter(1)]",
	listType			= "EnumerateTable", 
	listDataTag			= "damageTaken,[WindowParameter(1)],damageTypeDetails",
	barValueTag			= "Amount",
	filterTag			= "1",
	fightIndex			= -1,
	text				= { { tag = "[Rank]. [Key] ([Count])" }, { tag = "[BarValue:Short]" }, { tag = "[(BarValue*100/TotalBarValue):Format(\"%.1f%%\")]", visible = false }, count = 3 },
	description			= L["Damage Type Taken Details"],
	selectable			= false,
	colorTypeList		= { "DamageType", count = 1 },
}

Assessment.DefaultDisplaySets.DamageTakenDetails =
{
	titleTag			= "[(FightIndex ~= 0):\"Fight \"]Damage Taken: [WindowParameter(1)]",
	listType			= "EnumerateTable", 
	listDataTag			= "damageTaken,[WindowParameter(1)],attackDetails",
	barValueTag			= "Amount",
	filterTag			= "1",
	fightIndex			= -1,
	text				= { { tag = "[Rank]. [Key] ([Count])" }, { tag = "[BarValue:Short]" }, { tag = "Average: [(BarValue/Count):Format(\"%.1f\")][MaximumAmount:Prefix(\", Maximum: \")]", visible = false }, count = 3 },
	description			= L["Damage Taken Details"],
	selectable			= false,
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= L["Damage Taken Hit Details"],
	onClickData			= "[WindowParameter(1)],[Key]",
	colorTypeList		= { "SpellDamageType", count = 1 },
}

Assessment.DefaultDisplaySets.DamageTaken =
{
	titleTag			= "Damage Taken: [TotalBarValue:Short]",
	listType			= "GroupMembers", 
	barValueTag			= "DamageTaken", 
	filterTag			= "BarValue ~= 0",
	fightIndex			= 0,
	text				= { { }, { tag= "[BarValue:Short]" }, { tag = "[(BarValue*100/TotalBarValue):Format(\"%.1f%%\")]", visible = false }, count = 3 },
	description			= L["Damage Taken"],
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= string.format("[Select(IsControlKeyDown, %q, %q)]", L["Damage Type Taken Details"], L["Damage Taken Details"]),
	onClickData			= "[Key]",
	segmentEnable		= true,
	segmentDisplaySet	= L["Damage Type"],
	segmentData			= "damageTaken,[Key]",
	colorTypeList		= { "Class", count = 1 },
}

Assessment.DefaultDisplaySets.FightDamageTaken =
{
	titleTag			= "Fight Damage Taken: [TotalBarValue:Short]",
	listType			= "GroupMembers", 
	barValueTag			= "DamageTaken", 
	filterTag			= "BarValue ~= 0",
	fightIndex			= 1,
	text				= { { }, { tag= "[BarValue:Short]" }, { tag = "[(BarValue*100/TotalBarValue):Format(\"%.1f%%\")]", visible = false }, count = 3 },
	description			= L["Fight Damage Taken"],
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= string.format("[Select(IsControlKeyDown, %q, %q)]", L["Damage Type Taken Details"], L["Damage Taken Details"]),
	onClickData			= "[Key]",
	segmentEnable		= true,
	segmentDisplaySet	= L["Damage Type"],
	segmentData			= "damageTaken,[Key]",
	colorTypeList		= { "Class", count = 1 },
}

-----------------------------------------------------------------------------

local function getColor(passValue)
	return unpack(profileColors[passValue])
end

local function setColor(passValue,r, g, b)
	profileColors[passValue] = { r, g, b }
	Assessment:RedrawAll()
end

Assessment.Options.args.data.args.damage =
{
	type = "group",
	name = L["Damage"],
	desc = L["Damage Options."],
	args =
	{
		gatherDamageType =
		{
			type = "text",
			name = L["Damage Type Data"],
			desc = L["Information regarding damage types taken: Fire, Frost, etc."],
			get = function() return profile.gatherDamageTypeDataFilter end,
			set = function(v) profile.gatherDamageTypeDataFilter = v AssessmentDamage:OnInitialize() end,
			validate = { NONE = L["FILTER_NONE"], SELF = L["FILTER_SELF"], ALL = L["FILTER_ALL"] }
		},
		gatherAttackData =
		{
			type = "text",
			name = L["Attack Data"],
			desc = L["Information about each attack used."],
			get = function() return profile.gatherAttackDataFilter end,
			set = function(v) profile.gatherAttackDataFilter = v AssessmentDamage:OnInitialize() end,
			validate = { NONE = L["FILTER_NONE"], SELF = L["FILTER_SELF"], ALL = L["FILTER_ALL"] }
		},
		gatherHitData =
		{
			type = "text",
			name = L["Hit Data"],
			desc = L["Detailed information about each attack used."],
			get = function() return profile.gatherHitDataFilter end,
			set = function(v) profile.gatherHitDataFilter = v AssessmentDamage:OnInitialize() end,
			validate = { NONE = L["FILTER_NONE"], SELF = L["FILTER_SELF"], ALL = L["FILTER_ALL"] }
		},
		gatherHitData =
		{
			type = "text",
			name = L["Max Data"],
			desc = L["Gather maximum hit data."],
			get = function() return profile.gatherMaximumDataFilter end,
			set = function(v) profile.gatherMaximumDataFilter = v AssessmentDamage:OnInitialize() end,
			validate = { NONE = L["FILTER_NONE"], SELF = L["FILTER_SELF"], ALL = L["FILTER_ALL"] }
		},
		mergePetWithOwner =
		{
			type = "toggle",
			name = L["Merge Pet Damage"],
			desc = L["Merges damage dealt by pets with their owners data."],
			get = function() return profile.mergePetWithOwner end,
			set = function(v) profile.mergePetWithOwner = v end,
		},
		color =
		{
			type = "group",
			name = L["Colors"],
			desc = L["Color options"],
			args =
			{
				-- Filled in below
			},
		},
	}
}

-----------------------------------------------------------------------------

local localDamageTypeToColorName = 
{ 
	[SPELL_SCHOOL0_CAP] = "physical",
	[SPELL_SCHOOL1_CAP] = "holy",
	[SPELL_SCHOOL2_CAP] = "fire",
	[SPELL_SCHOOL3_CAP] = "nature",
	[SPELL_SCHOOL4_CAP] = "frost",
	[SPELL_SCHOOL5_CAP] = "shadow",
	[SPELL_SCHOOL6_CAP] = "arcane",
	[UNKNOWN]			= "unknown"
}

for k,v in pairs(localDamageTypeToColorName) do
	Assessment.Options.args.data.args.damage.args.color.args[v] =
	{
		type = "color",
		name = k,
		desc = k,
		get = getColor,
		set = setColor,
		passValue = v
	}
end

-----------------------------------------------------------------------------

Assessment.ColorType.DamageType = 
{
	method = function(fightData, data)
				local colorName = localDamageTypeToColorName[data.key]
				if not colorName then return nil end
				return profileColors[colorName]
			 end,
	description = L["Damage Type"]
}

Assessment.ColorType.SpellDamageType = 
{
	method = function(fightData, data)
				local damageType = data.value.damageType
				if not damageType then return end
				
				return profileColors[damageType]
			 end,
	description = L["Damage Type"]
}

-----------------------------------------------------------------------------

Assessment.DefaultTags.DamageDealt =
{
	tag			= "[DamageDealt:Short]",
	fightIndex	= 0,
	description	= L["Damage Dealt"],
}

Assessment.DefaultTags.FightDamageDealt =
{
	tag			= "[DamageDealt:Short]",
	fightIndex	= 1,
	description	= L["Fight Damage Dealt"],
}

Assessment.DefaultTags.DamageTaken =
{
	tag			= "[DamageTaken:Short]",
	fightIndex	= 0,
	description	= L["Damage Taken"],
}

Assessment.DefaultTags.FightDamageTaken =
{
	tag			= "[DamageTaken:Short]",
	fightIndex	= 1,
	description	= L["Fight Damage Taken"],
}

Assessment.DefaultTags.DPS =
{
	tag			= "[(DamageDealt / Maximum(CombatDuration, 1)):Format(\"%.1f\")]",
	fightIndex	= 1,
	description	= L["DPS"],
}

-----------------------------------------------------------------------------

function AssessmentDamage:OnInitialize()
	profile = self.db.profile
	profileColors = profile.colors
	gatherDamageTypeDataMethod = gatherFilterMethods[profile.gatherDamageTypeDataFilter]
	gatherAttackDataMethod = gatherFilterMethods[profile.gatherAttackDataFilter]
	gatherHitDataMethod = gatherFilterMethods[profile.gatherHitDataFilter]
	gatherMaximumDataMethod = gatherFilterMethods[profile.gatherMaximumDataFilter]
end

function AssessmentDamage:OnEnable()
	self:RegisterParserEvent({ eventType = "Damage" }, "OnParserDamageEvent")
	self:RegisterParserEvent({ eventType = "Miss" }, "OnParserMissEvent")
end

function AssessmentDamage:OnDisable()
end

-----------------------------------------------------------------------------

local function AccumulateData(data, eventData)
	data.count = data.count + 1
	data.amount = data.amount + eventData.amount
end

local petToOwnerTable = { pet = "player" }
for i=1,4 do petToOwnerTable["partypet"..i] = "party"..i end
for i=1,40 do petToOwnerTable["raidpet"..i] = "raid"..i end

-----------------------------------------------------------------------------

function AssessmentDamage:NewDataTable()
	local data = self:NewTable()
	data.count = 0
	data.amount = 0
	return data
end

-----------------------------------------------------------------------------

function AssessmentDamage:UpdateDamageData(dataTable, member, eventData, attackType, abilityName)
	local data = dataTable[member]
	if not data then
		data = self:NewDataTable()
		data.attackDetails = self:NewTable()
		data.damageTypeDetails = self:NewTable()
		dataTable[member] = data
	end
	AccumulateData(data, eventData)
	
	local gatherMaximum = gatherMaximumDataMethod(member)
	if gatherMaximum then
		local amount = eventData.amount
		if not data.maximumAmount then
			data.maximumAmount = amount
			data.maximumAmountAttack = abilityName
		elseif amount > data.maximumAmount then
			data.maximumAmount = amount
			data.maximumAmountAttack = abilityName
		end
	end

	if gatherDamageTypeDataMethod(member) then
		local damageTypeDetailsParent = data.damageTypeDetails
		local damageTypeDetails = damageTypeDetailsParent[eventData.damageTypeLocal]
		if not damageTypeDetails then
			damageTypeDetails = self:NewDataTable()
			damageTypeDetailsParent[eventData.damageTypeLocal] = damageTypeDetails
		end
		AccumulateData(damageTypeDetails, eventData)
	end

	if gatherAttackDataMethod(member) then	
		local attackDetailsParent = data.attackDetails
		local attackDetails = attackDetailsParent[abilityName]
		if not attackDetails then
			attackDetails = self:NewDataTable()
			attackDetails.hitDetails = self:NewTable()
			attackDetailsParent[abilityName] = attackDetails
		end
		attackDetails.damageType = localDamageTypeToColorName[eventData.damageTypeLocal]
		AccumulateData(attackDetails, eventData)

		if gatherMaximum then
			local amount = eventData.amount
			if not attackDetails.maximumAmount then
				attackDetails.maximumAmount = amount
				attackDetails.maximumAmountAttack = abilityName
			elseif amount > attackDetails.maximumAmount then
				attackDetails.maximumAmount = amount
				attackDetails.maximumAmountAttack = abilityName
			end
		end
		
		if gatherHitDataMethod(member) then
			local hitDetails = attackDetails.hitDetails
			local attackTypeDetails = hitDetails[attackType]
			if not attackTypeDetails then
				attackTypeDetails = self:NewDataTable()
				hitDetails[attackType] = attackTypeDetails
			end
			AccumulateData(attackTypeDetails, eventData)
			
			if eventData.absorbAmount ~= 0 then
				local type = L["Partial Absorb"]
				local attackTypeDetails = hitDetails[type]
				if not attackTypeDetails then
					attackTypeDetails = self:NewDataTable()
					hitDetails[type] = attackTypeDetails
				end
				attackTypeDetails.count = attackTypeDetails.count + 1
				attackTypeDetails.amount = attackTypeDetails.amount + eventData.absorbAmount
			end

			if eventData.blockAmount ~= 0 then
				local type = L["Partial Block"]
				local attackTypeDetails = hitDetails[type]
				if not attackTypeDetails then
					attackTypeDetails = self:NewDataTable()
					hitDetails[type] = attackTypeDetails
				end
				attackTypeDetails.count = attackTypeDetails.count + 1
				attackTypeDetails.amount = attackTypeDetails.amount + eventData.blockAmount
			end

			if eventData.resistAmount ~= 0 then
				local type = L["Partial Resist"]
				local attackTypeDetails = hitDetails[type]
				if not attackTypeDetails then
					attackTypeDetails = self:NewDataTable()
					hitDetails[type] = attackTypeDetails
				end
				attackTypeDetails.count = attackTypeDetails.count + 1
				attackTypeDetails.amount = attackTypeDetails.amount + eventData.resistAmount
			end
		end
	end
end

-----------------------------------------------------------------------------

function AssessmentDamage:OnParserDamageEvent(eventData)
	local attackType
	if eventData.isDoT then
		attackType = L["Tick"]
	elseif eventData.isCrit then
		attackType = L["Critical Hit"]
	else
		attackType = L["Hit"]
	end
	
	local abilityName = eventData.abilityName or L["Melee"]

	local sourceName = eventData.sourceName
	if profile.mergePetWithOwner then
		local sourceOwnerID = petToOwnerTable[eventData.sourceID]
		if sourceOwnerID then
			abilityName = L["Pet: "]..abilityName
			sourceName = UnitName(sourceOwnerID)
		end
	end
	
	for data in self:IterateUpdateDataTables() do
		data.dataUpdateTimes.damage = GetTime()
		
		local damageDealt = data.damageDealt
		if not damageDealt then
			damageDealt = self:NewTable()
			data.damageDealt = damageDealt
		end

		local damageTaken = data.damageTaken
		if not damageTaken then
			damageTaken = self:NewTable()
			data.damageTaken = damageTaken
		end

		self:UpdateDamageData(damageDealt, sourceName, eventData, attackType, abilityName)
		self:UpdateDamageData(damageTaken, eventData.recipientName, eventData, attackType, abilityName)
	end
end

-----------------------------------------------------------------------------

function AssessmentDamage:UpdateMissData(dataTable, member, eventData, abilityName)
	local data = dataTable[member]
	if not data then
		data = self:NewDataTable()
		data.attackDetails = self:NewTable()
		data.damageTypeDetails = self:NewTable()
		dataTable[member] = data
	end
	data.count = data.count + 1
	
	if gatherAttackDataMethod(member) then
		local attackDetailsParent = data.attackDetails
		local attackDetails = attackDetailsParent[abilityName]
		if not attackDetails then
			attackDetails = self:NewDataTable()
			attackDetails.hitDetails = self:NewTable()
			attackDetailsParent[abilityName] = attackDetails
		end
		attackDetails.count = attackDetails.count + 1
		
		if gatherHitDataMethod(member) then		
			local hitDetails = attackDetails.hitDetails
			local attackTypeDetails = hitDetails[eventData.missTypeLocal]
			if not attackTypeDetails then
				attackTypeDetails = self:NewDataTable()
				hitDetails[eventData.missTypeLocal] = attackTypeDetails
			end
			attackTypeDetails.count = attackTypeDetails.count + 1
		end
	end
end

-----------------------------------------------------------------------------

function AssessmentDamage:OnParserMissEvent(eventData)
	local abilityName = eventData.abilityName or L["Melee"]
	
	local sourceName = eventData.sourceName
	if profile.mergePetWithOwner then
		local sourceOwnerID = petToOwnerTable[eventData.sourceID]
		if sourceOwnerID then
			abilityName = L["Pet: "]..abilityName
			sourceName = UnitName(sourceOwnerID)
		end
	end
	
	for data in self:IterateUpdateDataTables() do
		data.dataUpdateTimes.damage = GetTime()
		
		local damageDealt = data.damageDealt
		if not damageDealt then
			damageDealt = self:NewTable()
			data.damageDealt = damageDealt
		end

		local damageTaken = data.damageTaken
		if not damageTaken then
			damageTaken = self:NewTable()
			data.damageTaken = damageTaken
		end

		self:UpdateMissData(damageDealt, sourceName, eventData, abilityName)
		self:UpdateMissData(damageTaken, eventData.recipientName, eventData, abilityName)
	end
end

-----------------------------------------------------------------------------
